<?xml version="1.0"?>

<!-- Written by Stefano Mazzocchi "stefano@apache.org" -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="page">
   <xsl:processing-instruction name="cocoon-format">type="text/html"</xsl:processing-instruction>
   <html>
    <head>
     <title>
      <xsl:value-of select="title"/>
     </title>
    </head>
    <body bgcolor="#ffffff">
     <xsl:apply-templates/>
    </body>
   </html>
  </xsl:template>

  <xsl:template match="title">
   <h1 align="center">
    <xsl:apply-templates/>
   </h1>
  </xsl:template>

  <xsl:template match="paragraph">
   <p align="center">
    <i>
     <xsl:apply-templates/>
    </i>
   </p>
  </xsl:template>

  <xsl:template match="ROWSET">
   <H1 align="center">
     Table Data
     <xsl:apply-templates/>
   </H1>
  </xsl:template>

  <xsl:template match="ROW">
    <H2 align="left">
    <ul>
     Record #
     <xsl:apply-templates/>
    </ul>
    </H2>
  </xsl:template>

  <xsl:template match="number">
   <h4 align="left">
    <li>
     <xsl:apply-templates/>
    </li>
   </h4>
  </xsl:template>

  <xsl:template match="name">
   <h4 align="left">
    <li>
     <xsl:apply-templates/>
    </li>
   </h4>
  </xsl:template>

</xsl:stylesheet>